비트코인에 버그..."마음대로 찍을 수 있어"

임유경 기자2018.09.24

  • 글자 작게
  • 글자 크게

비트코인 개발팀 긴급 패치 배포...1년전 생성

비트코인에 치명적 버그(오류)가 발견됐다. 버그를 악용할 경우 비트코인 네트워크를 마비시킬 수 있는 것은 물론, 비트코인을 초과 발행해 인플레이션을 일으킬 수 있는 것으로 알려졌다. 이는 비트코인에 대한 신뢰 자체를 무너뜨릴 수 있는 중대한 문제다.

또, 이번 버그가 최초 생성된 것이 1년 전이라, 거의 모든 비트코인 노드가 영향을 받고 있고 비트코인에서 포크(특정 시점 소스코드를 복사해 새로운 블록체인을 만드는 행위)해 나온 다른 코인에도 영향을 준다는 점에서 파급력이 상당하다는 평가다.

비트코인 개발팀은 긴급히 패치를 배포하며, 버그 퇴치에 나섰다.

23일(현지시간) 비트코이니스트, 코인데스크 등 주요 암호화폐 전문 매체는 비트코인 프로토콜에 이같은 위험을 안고 있는 취약점 'CVE-2018-17144'가 보고됐다고 보도했다.

보도에 따르면 이 버그는 비트코인캐시 개발자인 아매니(Awemany)가 지난 17일 처음 발견해 비트코인 코어 개발팀에 보고했다. 처음 보고했을 때만 해도, 이 버그는 '서비스 거부 공격' 위험으로 알려졌다. 서비스 거부 공격은 해커가 대량의 가짜 거래요청(트랜잭션)을 일으켜 네트워크가 정상적인 서비스를 할 수 없게 마비시키는 공격이다.

이후 비트코인 개발팀이 살펴 본 결과 이 버그는 서비스 거부 공격뿐 아니라, 인플레이션 발생 위험도 내포하고 있는 것을 확인했다. 해커가 새 비트코인을 마음대로 찍어 낼 수 있는 취약점이다. 비트코인은 총 2천100만 개만 발행되도록 설계되어 있는데, 해커가 추가로 새 비트코인을 찍어 낼 경우 인플레이션(가치 하락)이 발생할 수 있다. 무엇보다 비트코인이 가지고 있는 상징적인 의미를 고려하면, 전체 암호화폐 시장에 대한 불신으로 이어질 수 있는 심각한 문제다.

이 버그는 지난해 9월 배포한 비트코인 0.15버전에서 처음 발견됐다. 미사용 트랜잭션 아웃풋의 추적을 단순화하는 기능을 만들면서 해당 버그가 생긴 것으로 알려졌다.

지난 7월 배포한 비트코인 0.16.2버전까지 모두 이 버그의 영향을 받는다. 또, 이들 버전에서 포크해 만든 모든 알트코인(비트코인 이외의 암호화폐)도 영향권 안에 있다.

비트코인 개발팀은 지난 18일 버그 패치가 반영된 비트코인 0.16.3 버전을 배포했다. 채굴자들의 빠른 협조로, 현재 전체 비트코인 채굴 중 절반은 버그 패치가 완료된 최신 버전에서 일어나고 있다.

비트코인 개발팀은 업그레이드 보고서를 통해 "이 버그를 악용한 취약점 공격 시도를 우려할 필요가 없다"고 강조했다.

임유경 기자 / lyk@zdnet.co.kr

X